﻿/*
 _____   _                 _                     
| ____| | |  _   _   ___  (_)  _   _   _ __ ___  
|  _|   | | | | | | / __| | | | | | | | '_ ` _ \ 
| |___  | | | |_| | \__ \ | | | |_| | | | | | | |
|_____| |_|  \__, | |___/ |_|  \__,_| |_| |_| |_|
             |___/                               
*/

const conf = new JsonConfigFile("./plugins/Elysium/config/config.json");
const config = conf.init("config", {});
const module = conf.init("modules", {});

let lang = config.语言;

const LANG = new JsonConfigFile(`./plugins/Elysium/Lang/${lang}.json`)
const Lang = LANG.init("LANG", {});

let ORI_ERROR = Lang.ori_error,
    MODESWITCH_COMMAND = Lang.modeswitch_command;


let Nick = module.Nick,
    DeathMode = module.DeathMode,
    Fly = module.Fly,
    Speed = module.Speed,
    GameMode = module.GameMode,
    PlayerInformation = module.PlayerInformation,
    Scale = module.Scale,
    God = module.God,
    Offhand = module.Offhand,
    Afk = module.Afk,
    Menu = module.Menu,
    Sign = module.Sign,
    Item = module.Item,
    ThrowSieve = module.ThrowSieve,
    MoreCommand = module.MoreCommand,
    SmallCapabilities = module.smallCapabilities,
    OPTP = module.OPTP,
    Tick = module.Tick,
    Spawn = module.Spawn,
    Tps = module.Tps,
    Ping = module.Ping,
    Motd = module.Motd,
    Sidebar = module.Sidebar,
    原神启动 = module.原神启动;

// let nick = {'Nick': { path: './Elysium/Player/Nick.js' }},
//     deathmode = {'DeathMode': { path: './Elysium/Player/DeathMode.js' }},
//     fly = {'Fly': { path: './Elysium/Player/Fly.js' }},
//     speed = {'Speed': { path: './Elysium/Player/Speed.js' }},
//     gamemode = {'GameMode': { path: './Elysium/Player/GameMode.js' }},
//     playerinformation = {'PlayerInformation': { path: './Elysium/Player/PlayerInformation.js' }},
//     scale = {'Scale': { path: './Elysium/Player/Scale.js' }},
//     god = {'God': { path: './Elysium/Player/God.js' }},
//     offhand = {'Offhand': { path: './Elysium/Player/Offhand.js' }},
//     afk = {'Afk': { path: './Elysium/Player/Afk.js' }},
//     menu = {'Menu': { path: './Elysium/Capabilities/Menu.js' }},
//     sign = {'Sign': { path: './Elysium/Capabilities/Sign.js' }},
//     item = {'Item': { path: './Elysium/Capabilities/Item.js' }},
//     throwsieve = {'ThrowSieve': { path: './Elysium/Capabilities/ThrowSieve.js' }},
//     morecommand = {'MoreCommand': { path: './Elysium/Capabilities/MoreCommand.js' }},
//     smallCapabilities = {'SmallCapabilities': { path: './Elysium/Capabilities/SmallCapabilities.js' }},
//     optp = {'OPTP': { path: './Elysium/Capabilities/OPTP.js' }},
//     tick = {'Tick': { path: './Elysium/Capabilities/Tick.js' }},
//     spawn = {'Spawn': { path: './Elysium/Capabilities/Spawn.js' }},
//     tps = {'Tps': { path: './Elysium/Capabilities/Tps.js' }},
//     ping = {'Ping': { path: './Elysium/Capabilities/Ping.js' }},
//     motd = {'Motd': { path: './Elysium/Capabilities/Motd.js' }},
//     sidebar = {'Sidebar': { path: './Elysium/Capabilities/Sidebar.js' }},
//     Genshin_start = {'原神启动': { path: './Elysium/Capabilities/原神启动.js' }};

const modules = {
    //player
    'DeathMode': { path: './Elysium/Player/DeathMode.js' },
    'Fly': { path: './Elysium/Player/Fly.js' },
    'Speed': { path: './Elysium/Player/Speed.js' },
    'GameMode': { path: './Elysium/Player/GameMode.js' },
    'PlayerInformation': { path: './Elysium/Player/PlayerInformation.js' },
    'Scale': { path: './Elysium/Player/Scale.js' },
    'God': { path: './Elysium/Player/God.js' },
    'Offhand': { path: './Elysium/Player/Offhand.js' },
    'Afk': { path: './Elysium/Player/Afk.js' },
    //Capabilities
    'Menu': { path: './Elysium/Capabilities/Menu.js' },
    'Sign': { path: './Elysium/Capabilities/Sign.js' },
    'Item': { path: './Elysium/Capabilities/Item.js' },
    'ThrowSieve': { path: './Elysium/Capabilities/ThrowSieve.js' },
    'MoreCommand': { path: './Elysium/Capabilities/MoreCommand.js' },
    'smallCapabilities': { path: './Elysium/Capabilities/smallCapabilities.js' },
    'OPTP': { path: './Elysium/Capabilities/OPTP.js' },
    'Tick': { path: './Elysium/Capabilities/Tick.js' },
    'Spawn': { path: './Elysium/Capabilities/Spawn.js' },
    'Tps': { path: './Elysium/Capabilities/Tps.js' },
    'Ping': { path: './Elysium/Capabilities/Ping.js' },
    'Motd': { path: './Elysium/Capabilities/Motd.js' },
    'Sidebar': { path: './Elysium/Capabilities/Sidebar.js' },
    '原神启动': { path: './Elysium/Capabilities/原神启动!.js' },
};

// 尝试加载每个模块并将结果存储在模块对象中
for (const moduleName in modules) {
    try {
        require(modules[moduleName].path);
        modules[moduleName].loaded = true;
    } catch {
        modules[moduleName].loaded = false;
    }
}

const PLUGINS_NAME = "Elysium";
const PLUGINS_URI = "https://github.com/XT-xiaotong/Elysium";
const PLUGINS_AUTHOR = "xiaotong";
const PLUGINS_VERSION = "1.4.0-beta";

colorLog("pink", `
         _____   _                 _                     
        | ____| | |  _   _   ___  (_)  _   _   _ __ ___  
        |  _|   | | | | | | / __| | | | | | | | '_ ' _ \\
        | |___  | | | |_| | \\__ \\ | | | |_| | | | | | | |
        |_____| |_|  \\__, | |___/ |_|  \\__,_| |_| |_| |_|
                    |___/
               
    -------- ${PLUGINS_URI} --------
         By: ${PLUGINS_AUTHOR}     Plugins: ${PLUGINS_NAME}       Version: ${PLUGINS_VERSION}
`)

mc.listen("onJoin", (player) => {
    player.sendToast('进服通知', '手持钟右键可打开主菜单')
});

// 插件主命令
mc.listen("onServerStarted", () => {
    const ELYSIUM = mc.newCommand("elysium", `${MODESWITCH_COMMAND}`, PermType.Any);
    ELYSIUM.setAlias("es");
    ELYSIUM.setEnum("mode", ["list", "help", "me", "version"]);
    ELYSIUM.mandatory("mode", ParamType.Enum, "mode", 1);
    ELYSIUM.mandatory("name", ParamType.RawText);
    ELYSIUM.overload(["mode"]);
    ELYSIUM.setCallback((_cmd, ori, out, res) => {
        switch (res.mode) {
            case "list":
                const loadedModules = [];
                const failedModules = [];
                for (const moduleName in modules) {
                    const emoji = modules[moduleName].loaded ? "§a✔§r" : "§4✘§r";
                    const message = `${moduleName}模块 ${emoji}`;

                    modules[moduleName].loaded ? loadedModules.push(message) : failedModules.push(message);
                }
                const allModules = loadedModules.concat(failedModules);
                const response = `成功加载以下模块:\n${allModules.join('\n')}`;
                if (ori.player) {
                    ori.player.tell(response);
                } else if (!ori.player) {
                    log(response);
                }
                break;
        }
        if (res.mode == "version") {
            if (ori.player) {
                ori.player.tell(`Elysium插件版本为 v${PLUGINS_VERSION}`);
            } else if (!ori.player) {
                log(`Elysium插件版本为 v${PLUGINS_VERSION}`);
            }
        }
        if (res.mode == "help") {
            if (ori.player) {
                ori.player.tell(`-------------------
Elysium插件帮助:           
1. 指令 elysium help 插件帮助
2. 指令 elysium list 获取功能列表
3. 指令 elysium me 获取我的信息
4. 指令 elysium version 获取插件版本
5. 指令 deathmode或dm 开启或关闭死神模式
6. 指令 fly 开启或关闭飞行模式
7. 指令 god 开启或关闭无敌模式
8. 指令 item 查看掉落物和箭矢数量
9. 指令 menu 打开主菜单
10. 指令 modeswitch或g 修改玩家游戏模式
11. 指令 nick 修改玩家昵称
12. 指令 optp 打开传送菜单[需要op权限]
13. 指令 playerinformation或者pi 获取玩家详细信息
14. 指令 scale 修改玩家大小
15. 指令 sdl,tql,awsl,wbs.damn,pa,ssb,sds,shen 发送特殊消息
16. 指令 sign 打开签到菜单
17. 指令 spawn 回到出生点
18. 指令 speed 修改玩家移动速度
19. 指令 throwsieve或ts 掷出筛子
20. 指令 tick 修改游戏tick
21. 指令 offhand 主副手物品切换
22. 指令 tps 获取服务器TPS
23. 指令 ping 获取延迟
24. 指令 afk 挂机
25. 指令 sidebar 侧边栏
-------------------`)
            } else if (!ori.player)
                log(`
-------------------
1. 指令 elysium help 插件帮助
2. 指令 elysium list 获取功能列表
3. 指令 elysium me 获取我的信息
4. 指令 elysium version 获取插件版本
5. 指令 deathmode或dm 开启或关闭死神模式
6. 指令 fly 开启或关闭飞行模式
7. 指令 god 开启或关闭无敌模式
8. 指令 item 查看掉落物和箭矢数量
9. 指令 menu 打开主菜单
10. 指令 modeswitch或g 修改玩家游戏模式
11. 指令 nick 修改玩家昵称
12. 指令 optp 打开传送菜单[需要op权限]
13. 指令 playerinformation或者pi 获取玩家详细信息
14. 指令 scale 修改玩家大小
15. 指令 sdl,tql,awsl,wbs.damn,pa,ssb,sds,shen 发送特殊消息
16. 指令 sign 打开签到菜单
17. 指令 spawn 回到出生点
18. 指令 speed 修改玩家移动速度
19. 指令 throwsieve或ts 掷出筛子
20. 指令 tick 修改游戏tick
21. 指令 offhand 主副手物品切换
22. 指令 tps 获取服务器TPS
23. 指令 ping 获取延迟
24. 指令 afk 挂机
25. 指令 sidebar 侧边栏
-------------------`)
        }
        if (res.mode == "me") {
            if (!ori.player) return out.error(ORI_ERROR);
            let gameMode = ori.player.gameMode;
            let perm = ori.player.permLevel;
            switch (gameMode) {
                case 0:
                    gameMode = "生存";
                    break;
                case 1:
                    gameMode = "创造";
                    break;
                case 2:
                    gameMode = "冒险";
                    break;
                case 6:
                    gameMode = "旁观";
            }
            switch (perm) {
                case 0:
                    perm = "成员";
                    break;
                case 1:
                    perm = "管理员";
                    break;
            }
            ori.player.tell(`你的信息:
玩家名: ${ori.player.name}
游戏模式: ${gameMode}
权限: ${perm}
        `)
        }
    });
    ELYSIUM.setup();
});

mc.listen("onServerStarted", function () {
    logger.log(`加载成功! v${PLUGINS_VERSION}  作者:${PLUGINS_AUTHOR} 感谢使用!`);
});