const conf = new JsonConfigFile("./plugins/Elysium/config/config.json")
const config = conf.init("config", {});

let lang = config.语言,
    afk_times = config.触发挂机时间;

const LANG = new JsonConfigFile(`./plugins/Elysium/Lang/${lang}.json`)
const Lang = LANG.init("LANG", {});

let ORI_ERROR = Lang.ori_error,
    AFK_COMMAND = Lang.afk_command,
    AFK_MSG = Lang.afk_msg,//进入afk状态提示
    UNAFK_MSG = Lang.unafk_msg;//解除afk状态提示

const AfkTime = afk_times//多少秒触发挂机

var Afk = {}

function PlayerMove(player) {
    mc.broadcast(`§7 ${player.name} ${UNAFK_MSG}`)
    //这里是移动的玩家
}

function PlayerAfk(player) {
    if (Afk[player.realName].time <= AfkTime) {
        mc.broadcast(`§7 ${player.name} ${AFK_MSG}`)
    }
    //这里是挂机的玩家
}

mc.listen("onJoin", (player) => {
    Afk[player.realName] = {
        pos: player.pos,
        direction: player.direction,
        time: 0
    };
});

mc.listen("onChat", (player, _msg) => {//玩家切换潜行状态
    if (Afk[player.realName].time >= AfkTime) {
        PlayerMove(player)
    }
    Afk[player.realName].time = 0
})

mc.listen("onSneak", (player, _isSneaking) => {//发送消息自动解除afk状态
    if (Afk[player.realName].time >= AfkTime) {
        PlayerMove(player)
    }
    Afk[player.realName].time = 0
})

mc.listen("onAttackEntity", (player, _entity, _damage) => {//玩家攻击实体自动解除afk状态
    if (Afk[player.realName].time >= AfkTime) {
        PlayerMove(player)
    }
    Afk[player.realName].time = 0
})

mc.listen("onAttackBlock", (player, _block, _item) => {//玩家攻击方块自动解除afk状态
    if (Afk[player.realName].time >= AfkTime) {
        PlayerMove(player)
    }
    Afk[player.realName].time = 0
})

mc.listen("onUseItem", (player, _item) => {//玩家使用物品自动解除afk状态
    if (Afk[player.realName].time >= AfkTime) {
        PlayerMove(player)
    }
    Afk[player.realName].time = 0
})

mc.listen("onUseItemOn", (player, _item, _block, _side, _pos) => {//玩家对方块使用物品自动解除afk状态
    if (Afk[player.realName].time >= AfkTime) {
        PlayerMove(player)
    }
    Afk[player.realName].time = 0
})

mc.listen("onServerStarted", () => {
    const AFK = mc.newCommand("afk", `${AFK_COMMAND}`, PermType.Any)
    AFK.setCallback(function (_cmd, ori, out, _res) {
        if (!ori.player) return out.error(ORI_ERROR);
        if (ori.player) {//使用指令进入afk状态
            Afk[ori.player.realName].time = AfkTime
        };
    })
    AFK.overload([]);
    AFK.setup();
})

setInterval(() => {
    const Players = mc.getOnlinePlayers()
    let PlayerData = {}

    for (let i in Players) {
        let player = Players[i]
        if (Afk[player.realName]) {
            if (
                (Afk[player.realName].pos.x == player.pos.x)
                && (Afk[player.realName].pos.y == player.pos.y)
                && (Afk[player.realName].pos.z == player.pos.z)
                && (Afk[player.realName].pos.dim == player.pos.dim)
            ) {
                if (Afk[player.realName].time >= AfkTime) {
                    PlayerAfk(player)
                }
                Time = Afk[player.realName].time
                Time++
                PlayerData[player.realName] = {
                    pos: player.pos,
                    direction: player.direction,
                    time: Time
                }
            } else {
                if (Afk[player.realName].time >= AfkTime) {
                    PlayerMove(player)
                }
                PlayerData[player.realName] = {
                    pos: player.pos,
                    direction: player.direction,
                    time: 0
                }
                if (Afk[player.realName].time < AfkTime) {
                    Afk[player.realName].time = 0
                }
            }
        } else {
            PlayerData[player.realName] = {
                pos: player.pos,
                direction: player.direction,
                time: 0
            }
        }
    }
    Afk = PlayerData



}, 1000)//这里是刷新状态的时间